#!/usr/bin/python


from fileparsers_dance2ps import SongItem


import getopt
import sys

arrowcount = { "SINGLE": 4, "DOUBLE": 8, "COUPLE": 8, "6PANEL": 6, "8PANEL": 8 }
arrowsets = { "SINGLE": 1, "DOUBLE": 2, "COUPLE": 2, "6PANEL": 1, "8PANEL": 1 }

measurelen={'o': 1.0,
            'h': 1.0/2,
            'q': 1.0/4,
            'e': 1.0/8,
            'w': 1.0/12,
            's': 1.0/16,
            'f': 1.0/24,
            't': 1.0/32,
            'u': 1.0/48,
            'x': 1.0/64,
            'n': 1.0/192}


class psStepChart:
  def __init__(self,songinfo,secpercol=15):
    self.pscommand=[((-2,0,0),["""%!PS-Adobe-3.0
%%Title: """+songinfo['title']+"""
%%Creator: dance2ps
%%BoundingBox: letter
%%Pages: (atend)
%%EndComments
%%BeginProlog
/up {newpath /hold exch def
moveto 6 0 rmoveto
6 0 rlineto 6 -6 rlineto 0 -7 hold sub rlineto -6 6 rlineto 0 -11 rlineto -6 0 rlineto 0 11 rlineto -6 -6 rlineto 0 7 hold add rlineto closepath
} def
/down {newpath /hold exch def
hold sub moveto 6 -18 rmoveto
6 0 rlineto 6 6 rlineto 0 7 hold add rlineto -6 -6 rlineto 0 11 rlineto -6 0 rlineto 0 -11 rlineto -6 6 rlineto 0 -7 hold sub rlineto closepath
} def
/right {newpath /hold exch def
moveto 18 -6 rmoveto
0 -6 hold sub rlineto -6 -6 rlineto -7 0 rlineto 6 6 rlineto -11 0 rlineto 0 6 hold add rlineto 11 0 rlineto -6 6 rlineto 7 0 rlineto closepath
} def
/left {newpath /hold exch def
moveto 0 -6 rmoveto
0 -6 hold sub rlineto 6 -6 rlineto 7 0 rlineto -6 6 rlineto 11 0 rlineto 0 6 hold add rlineto -11 0 rlineto 6 6 rlineto -7 0 rlineto closepath
} def
/upright
{newpath /hold exch def
moveto 13.24264 -0.51472 rmoveto
4.24264  -4.24264 rlineto 0.00000  -8.48528 hold sub rlineto -4.94975  -4.94975 rlineto 0.00000   8.48528 rlineto -7.77817  -7.77817 rlineto -4.24264   4.24264 rlineto 0 hold rlineto 7.77817   7.77817 rlineto -8.48528   0.00000 rlineto 4.94975   4.94975 rlineto closepath
} def
/upleft
{newpath /hold exch def
moveto 0.51472   -4.75736 rmoveto 4.24264   4.24264 rlineto 8.48528   0.00000 rlineto 4.94975  -4.94975 rlineto -8.48528   0.00000 rlineto 7.77817  -7.77817 rlineto 0 hold -1 mul rlineto -4.24264  -4.24264 rlineto -7.77817   7.77817 rlineto 0.00000  -8.48528 rlineto -4.94975   4.94975 rlineto closepath
} def
/downleft
{newpath /hold exch def
moveto 4.75736  -17.48528 hold sub rmoveto -4.24264   4.24264 rlineto 0.00000   8.48528 hold add rlineto 4.94975   4.94975 rlineto 0.00000  -8.48528 rlineto 7.77817   7.77817 rlineto 4.24264  -4.24264 rlineto 0 hold -1 mul rlineto -7.77817  -7.77817 rlineto 8.48528   0.00000 rlineto -4.94975  -4.94975 rlineto closepath
} def
/downright
{newpath /hold exch def
moveto 17.48528  -13.2426 hold sub rmoveto -4.24264  -4.24264 rlineto -8.48528   0.00000 rlineto -4.94975   4.94975 rlineto 8.48528   0.00000 rlineto -7.77817   7.77817 rlineto 0 hold rlineto 4.24264   4.24264 rlineto 7.77817  -7.77817 rlineto 0.00000   8.48528 rlineto 4.94975  -4.94975 rlineto closepath
} def
/u
{/hold exch def /y exch def /x exch def
x y hold up 0.8 setgray fill stroke
x y hold up 1 setlinewidth 0 setgray stroke} def
/d
{/hold exch def /y exch def /x exch def
x y hold down 0.8 setgray fill stroke
x y hold down 1 setlinewidth 0 setgray stroke} def
/l
{/hold exch def /y exch def /x exch def
x y hold left 0.8 setgray fill stroke
x y hold left 1 setlinewidth 0 setgray stroke} def
/r
{/hold exch def /y exch def /x exch def
x y hold right 0.8 setgray fill stroke
x y hold right 1 setlinewidth 0 setgray stroke} def
/ul
{/hold exch def /y exch def /x exch def
x y hold upleft 0.8 setgray fill stroke
x y hold upleft 1 setlinewidth 0 setgray stroke} def
/ur
{/hold exch def /y exch def /x exch def
x y hold upright 0.8 setgray fill stroke
x y hold upright 1 setlinewidth 0 setgray stroke} def
/dr
{/hold exch def /y exch def /x exch def
x y hold downright 0.8 setgray fill stroke
x y hold downright 1 setlinewidth 0 setgray stroke} def
/ul
{/hold exch def /y exch def /x exch def
x y hold upleft 0.8 setgray fill stroke
x y hold upleft 1 setlinewidth 0 setgray stroke} def
"""]),((-1,2**30,0),["%%EndProlog"])]
    self.songinfo=songinfo
    
    self.arrowsize=18
    self.pagewidth=612
    self.pageheight=792
        
    self.topmarginsize=36
    self.bottommarginsize=36
    self.leftmarginsize=36
    self.rightmarginsize=36
    self.metadatahgt=72

    self.topmargin=self.pageheight-self.topmarginsize
    self.bottommargin=self.bottommarginsize
    self.leftmargin=self.leftmarginsize
    self.rightmargin=self.pagewidth-self.rightmarginsize
        
    self.stepspacetop=self.topmargin-self.metadatahgt
    self.stepspacebottom=self.bottommargin
    self.stepspaceleft=self.leftmargin
    self.stepspaceright=self.rightmargin
    
    self.stepspaceheight=self.stepspacetop-self.stepspacebottom
    self.stepspacewidth=self.stepspaceright-self.stepspaceleft
        
    self.secpercol=secpercol
    self.pointspersec=(self.stepspaceheight-self.arrowsize)*1.0/self.secpercol
    self.arrowsets=arrowsets[gametype]

    self.pagecount=0

    self.measuresyoffset=0
        
    if self.songinfo['gametype'] == 'SINGLE':
      self.arrowmap={0: ('l',1),
                     1: ('d',21),
                     2: ('u',41),
                     3: ('r',61)}
      self.arrowswidth=80
      self.timecols=1
      self.arrowsets=arrowsets[gametype]
    elif self.songinfo['gametype'] == 'DOUBLE':
      self.arrowmap={0: ('l',1),
                     1: ('d',21),
                     2: ('u',41),
                     3: ('r',61),
                     4: ('l',81),
                     5: ('d',101),
                     6: ('u',121),
                     7: ('r',141)}
      self.arrowswidth=160
      self.timecols=2
    elif self.songinfo['gametype'] == 'COUPLE':
      self.arrowmap={0: ('l',1),
                     1: ('d',21),
                     2: ('u',41),
                     3: ('r',61),
                     4: ('l',91),
                     5: ('d',111),
                     6: ('u',131),
                     7: ('r',151)}
      self.arrowswidth=170
      self.timecols=2
    elif self.songinfo['gametype'] == '6PANEL':
      self.arrowmap={0: ('l',1),
                     1: ('ul',21),
                     2: ('d',41),
                     3: ('u',61),
                     4: ('ur',81),
                     5: ('r',101)}
      self.arrowswidth=120
      self.timecols=1
    elif self.songinfo['gametype'] == '8PANEL':
      self.arrowmap={0: ('dl',1),
                     1: ('l',21),
                     2: ('ul',41),
                     3: ('d',61),
                     4: ('u',81),
                     5: ('ur',101),
                     6: ('r',121),
                     7: ('dr',141)}
      self.arrowswidth=160
      self.timecols=1
    else: raise 'Game type not supported.'

    self.holds = [None]*arrowcount[gametype]
            
    self.stepcolcount=int(self.stepspacewidth/self.arrowswidth)
    self.stepcolwidth=self.stepspacewidth/self.stepcolcount
    self.timecolwidth=(self.stepcolwidth-self.arrowswidth)/self.timecols
    
    self.secperpage=self.stepcolcount*self.secpercol

    # Set up a subroutine to draw page borders and seconds ticks.
    self.pscommand.append(((-1,-3,0),['/pageborders','{']))

    self.pscommand.append(((-1,-2,-4),['/s','{','setgray','moveto',self.timecolwidth,0,'rlineto','stroke','}','def']))
    for timecolside in range(self.timecols):
      for tick in range(self.secperpage):
        page,col,y=self.timewrap(self.secperpage+tick)
        self.pscommand.append(((-1,-2,-5),[self.stepspaceleft+col*self.stepcolwidth+(self.stepcolwidth-self.timecolwidth)*timecolside,y]))
        if tick%5: self.pscommand[-1][1].extend([.8,'s'])
        else: self.pscommand[-1][1].extend([0,'s'])
      self.pscommand.append(((-1,-2,-6),[0,'setgray']))


    self.pscommand.append(((-1,-1,0),
                           ['newpath',
                            self.bottommargin,self.leftmargin,'moveto',
                            self.rightmargin,self.bottommargin,'lineto',
                            self.rightmargin,self.topmargin,'lineto',
                            self.leftmargin,self.topmargin,'lineto','closepath',
                            self.stepspaceleft,self.stepspacetop,'moveto',
                            self.stepspaceright,self.stepspacetop,'lineto',
                            2,'setlinewidth','stroke',
                            'newpath',
                            self.stepspaceleft,self.stepspacebottom,'moveto',
                            self.stepcolcount,'{',0,self.stepspaceheight,'rlineto',self.stepcolwidth,-self.stepspaceheight,'rmoveto','}','repeat',
                            2,'setlinewidth','stroke',
                            'newpath',
                            self.stepspaceleft+self.timecolwidth,self.stepspacebottom,'moveto',
                            self.stepcolcount,'{',0,self.stepspaceheight,'rlineto',
                            self.stepcolwidth,-self.stepspaceheight,'rmoveto','}','repeat',1, 'setlinewidth','stroke']))
    if self.timecols==2:
      self.pscommand.append(((-1,-1,0),
                             ['newpath',
                              self.stepspaceleft+self.stepcolwidth-self.timecolwidth,self.stepspacebottom,'moveto',
                              self.stepcolcount,'{',0,self.stepspaceheight,'rlineto',
                              self.stepcolwidth,-self.stepspaceheight,'rmoveto','}','repeat',1, 'setlinewidth','stroke']))
    

    self.pscommand.append(((-1,0,2**30),['newpath',
                                           self.stepspaceleft+1,self.stepspacebottom+1,'moveto',
                                           self.stepspaceright-1,self.stepspacebottom+1,'lineto',
                                           self.stepspaceright-1,self.stepspacetop-1,'lineto',
                                           self.stepspaceleft+1,self.stepspacetop-1,'lineto','closepath','clip']))
    
    self.pscommand.append(((-1,1,0),
                           ['gsave','newpath',self.stepspaceleft,self.stepspacebottom+self.arrowsize/2,'moveto',
                            self.stepspacewidth,0,'rlineto',
                            self.stepspaceleft,self.stepspacetop-self.arrowsize/2,'moveto',
                            self.stepspacewidth,0,'rlineto','[1 1]',0,'setdash','stroke','grestore']))


    self.pscommand.append(((-1,2,0),['}','def']))

    # Define a subroutine to draw measure boundaries.
    self.pscommand.append(((-1,self.stepcolcount+3,0),['/m','{','newpath','moveto',
                              self.arrowswidth/self.arrowsets,0,'rlineto',0,'setgray',1,'setlinewidth','stroke','}','def']))

            
  def initnewpage(self):
    page=self.pagecount
    self.pscommand.append(((page,self.stepcolcount+2,0),['showpage']))
    self.pscommand.append(((page,-2,0),['%%Page: ',page+1,page+1]))
    self.plotmetadata(self.songinfo,page)
    self.pscommand.append(((page,0,2**30),['pageborders']))
    self.pagecount+=1



  def plotmetadata(self,songinfo,page):
    self.pscommand.append(((page,-1,0),['/Helvetica','findfont',16,'scalefont','setfont',self.leftmargin+2,self.topmargin-16,'moveto','('+songinfo['title']+')','show']))

    if songinfo['subtitle']:
      self.pscommand.append(((page,-1,0),['/Helvetica','findfont',12,'scalefont','setfont','( '+songinfo['subtitle']+')','show']))
      
    if songinfo['mix']:
      self.pscommand.append(((page,-1,0),['/Helvetica','findfont',12,'scalefont','setfont',self.leftmargin+2,self.topmargin-16*2,'moveto','(Collection: '+songinfo['mix']+')','show']))

    self.pscommand.append(((page,-1,0),['/Helvetica','findfont',12,'scalefont','setfont',self.pagewidth/2,self.topmargin-16*2,'moveto','(Artist: '+songinfo['artist']+')','show']))
        
    if songinfo['author']:
      self.pscommand.append(((page,-1,0),['/Helvetica','findfont',12,'scalefont','setfont',self.pagewidth/2,self.topmargin-16*3,'moveto','(Steps: '+songinfo['author']+')','show']))
            
    self.pscommand.append(((page,-1,0),['/Helvetica','findfont',12,'scalefont','setfont',self.rightmargin-72,self.topmargin-12,'moveto','(Page '+str(page+1)+' of '+str(self.totalpages)+')','show']))

    self.pscommand.append(((page,-1,0),['/Helvetica','findfont',12,'scalefont','setfont',self.leftmargin+2,self.topmargin-16*3,'moveto','('+songinfo['gametype']+':'+songinfo['difficulty']+':'+str(songinfo['rating'])+')','show']))

    
    self.pscommand.append(((page,-1,0),['/Helvetica','findfont',12,'scalefont','setfont',self.leftmargin+2,self.topmargin-16*4,'moveto','(Options: '+str(self.secpercol)+' sec/column, '+songinfo['meter']+' meter)','show']))
    



  def timewrap(self,time):
    return (int(time/self.secperpage),int(time/self.secpercol)%self.stepcolcount,self.stepspacetop-(time%self.secpercol)*self.pointspersec-self.arrowsize/2)

  def plotmeasurebreak(self,time,player=0):
      page,col,y=self.timewrap(time)
      self.pscommand.append(((page,self.stepcolcount,0),
                             [self.stepspaceleft+col*self.stepcolwidth+self.timecolwidth+player*self.arrowswidth/self.arrowsets,y+self.measuresyoffset,'m']))

  def plotarrow(self,time,dirinfo,hold = 0):
    page1,col1,y1=self.timewrap(time)
    page2,col2,y2=self.timewrap(time+hold)
    holdcols=[(page1+int((col1+c)/self.stepcolcount),(col1+c)%self.stepcolcount,y1+c*(self.stepspaceheight-self.arrowsize)) for c in range(1+(page2-page1)*self.stepcolcount+(col2-col1))]
    for page,col,y in holdcols:
      self.pscommand.append(((page,col,y),[self.stepspaceleft+col*self.stepcolwidth+self.timecolwidth+dirinfo[1],y+self.arrowsize/2,hold*self.pointspersec,dirinfo[0]]))


  def plotstep(self,time,step):
    arrows=step[1:]
    for panel in range(len(arrows)):
      if arrows[panel]==1:
        if self.holds[panel]<>None: # The starting time of a hold can (in theory) be 0...
          self.plotarrow(self.holds[panel],self.arrowmap[panel],time-self.holds[panel])
          self.holds[panel]=None
        else:
          self.plotarrow(time,self.arrowmap[panel])
      elif arrows[panel]==3:
        self.holds[panel]=time

  def plotwait(self,time,wait,player=0):
    page1,col1,y1=self.timewrap(time)
    page2,col2,y2=self.timewrap(time+wait)
    waitcols=[(page1+int((col1+c)/self.stepcolcount),(col1+c)%self.stepcolcount,y1+c*(self.stepspaceheight-self.arrowsize)) for c in range(1+(page2-page1)*self.stepcolcount+(col2-col1))]
    for page,col,y in waitcols:
      self.pscommand.append(((page,col,y),
                             ['newpath',
                              self.stepspaceleft+col*self.stepcolwidth+self.timecolwidth/2+(self.stepcolwidth-self.timecolwidth)*player,y,'moveto',
                              0,-wait*self.pointspersec,'rlineto',.5,'setgray','stroke']))
    self.lastbpmchange=time+wait

  def plotstop(self,time,stop,player=0):
    page1,col1,y1=self.timewrap(time)
    page2,col2,y2=self.timewrap(time+stop)
    stopcols=[(page1+int((col1+c)/self.stepcolcount),(col1+c)%self.stepcolcount,y1+c*(self.stepspaceheight-self.arrowsize)) for c in range(1+(page2-page1)*self.stepcolcount+(col2-col1))]
    for page,col,y in stopcols:
      self.pscommand.append(((page,col,y),
                             ['newpath',
                              self.stepspaceleft+col*self.stepcolwidth+self.timecolwidth/2+(self.stepcolwidth-self.timecolwidth)*player,y,'moveto',
                              0,-stop*self.pointspersec,'rlineto',0,'setgray','stroke']))
    self.lastbpmchange=time+stop

  def write(self,fname,songlength):
    self.totalpages=int(songlength/self.secperpage)+1
    for c in range(int(songlength/self.secperpage)+1):
      self.initnewpage()
    self.pscommand.append(((self.totalpages+1,0,0),["""%%Trailer
%%Pages:""",self.totalpages]))
    self.pscommand.append(((self.totalpages+1,1,0),["""%%EOF"""]))
    self.pscommand.sort(lambda x,y:cmp(x[0][:2]+(-x[0][2],),y[0][:2]+(-y[0][2],)))
    psfile=file(fname,'w')
    for dummy,command in self.pscommand:
      psfile.write(' '.join([str(x) for x in command])+'\n')
                

def printusage():
  print """Usage: ./dance2ps.py [OPTIONS] dancefile.ext GAMETYPE:DIFFICULTY outfile.ps
The following options are available:
   --help               print this message
   --measures=          set algorithm for drawing measures (default: auto) at this time, any other choice will not draw measures
   --meter=             set the meter of the song (i.e. 2/4, 3/8) (4/4 is the default)
   --sec-per-col=       set the scale at which the steps are graphed in seconds/column
"""
try:
  options=getopt.getopt(sys.argv[1:],'',['help','measures=','meter=','sec-per-col='])
  if ('--help','') in options[0]:
    printusage()
    sys.exit(0)
  songfname,gametype,outfname=options[1][:3]

  gametype,difficulty=gametype.split(':')
except getopt.GetoptError:
  printusage()
  sys.exit(1)
except ValueError:
  printusage()
  sys.exit(1)

if ('--help','') in options[0]:
  printusage()
  sys.exit(0)
  

song=SongItem(songfname)

# Extract the desired steps:
try:
  if arrowsets[gametype]==1:
    steps=[song.steps[gametype][difficulty]]
  else:
    steps=song.steps[gametype][difficulty]
except KeyError:
    print 'This step file does not have steps for this game type and difficulty.'
    sys.exit(1)


songinfo=song.info.copy()
songinfo['gametype']=gametype
songinfo['difficulty']=difficulty
songinfo['rating']=song.difficulty[gametype][difficulty]

try:
  meter=[opt[1] for opt in options[0] if opt[0]=='--meter'][0]
except IndexError:
  meter='4/4'
songinfo['meter']=meter
meter=float(meter.split('/')[0])/float(meter.split('/')[1])

try:
  secpercol=[opt[1] for opt in options[0] if opt[0]=='--sec-per-col'][0]
except IndexError:
  secpercol='15'
secpercol=float(secpercol)

try:
  measures=[opt[1] for opt in options[0] if opt[0]=='--measures'][0]
except IndexError:
  measures='auto'

psfile = psStepChart(songinfo,secpercol)

if gametype=='DOUBLE':
  measurelists=[] #(avetime,min,max)

# Initialize the values for the song loop:
for stepsetn in range(len(steps)):
  time = abs(song.info['gap']/1000.0)
  bpm = song.info['bpm']

  stop = 0
  measurepos=1
  lastnote=time
  if gametype=='DOUBLE':
    measurelist=[]
  
  for step in steps[stepsetn]:
    if type(step[0]) is int:
      measurelen[step[0]]=1.0/(step[0]/16)
    if step[0]=='W':
      psfile.plotwait(time+stop,step[1],stepsetn)
      time+=step[1]
      lastnote=time+stop-(measurelen['h']*4)/(bpm/60.0)
    elif step[0]=='S':
      psfile.plotstop(time,step[1],stepsetn)
      stop=step[1]
      continue
    elif step[0]=='D':
      psfile.plotwait(time+stop,step[1]/(bpm/60.0),stepsetn)
      time+=step[1]/(bpm/60.0)
      lastnote=time+stop-(measurelen['h']*4)/(bpm/60.0)
    elif step[0]=='B':
      bpm = step[1]
      continue
    elif step[0] in measurelen:
      psfile.plotstep(time,[step[0]]+[0]*(arrowcount[gametype]/arrowsets[gametype])*stepsetn+step[1:]+[0]*(arrowcount[gametype]/arrowsets[gametype])*(arrowsets[gametype]-stepsetn))
      measurepos+=measurelen[step[0]]
      if measures=='auto':
        if measurepos%meter<measurepos:
          measurepos%=meter
          if gametype=='DOUBLE':
            measurelist.append(( (time+lastnote)/2,lastnote,time,meter*2/(bpm/60.0)))
          else:
            psfile.plotmeasurebreak((time+lastnote)/2,stepsetn)
      lastnote=time
      time = time + (measurelen[step[0]]*4)/(bpm/60.0)

    if stop:
      lastnote=time+stop-(measurelen['h']*4)/(bpm/60.0)
      time += stop
      stop = 0
  if gametype=='DOUBLE':
    measurelists.append(measurelist)
  
if gametype=='DOUBLE':

  for x in range(len(measurelists[0])):
    m0=measurelists[0][x]
    for y in range(len(measurelists[1])):
      m1=measurelists[1][y]
      if abs(m0[0]-m1[0])<min(m0[3],m1[3]):
        measurelists[0][x]=measurelists[1][y]=((min(m0[2],m1[2])+max(m0[1],m1[1]))/2,
                                               max(m0[1],m1[1]), min(m0[2],m1[2]),min(m0[3],m1[3]))

  for p in range(2):
    for m in measurelists[p]:
      psfile.plotmeasurebreak(m[0],p)
    
psfile.write(outfname,time)
